//
//  ViewController.m
//  JSMessageExample
//
//  Created by Joshua Kehn on 10/27/14.
//  Copyright (c) 2014 KEHN. All rights reserved.
//

#import "ViewController.h"



@implementation ViewController
WKWebView  * webViewM2;

int counter;
-(void)awakeFromNib{
    
   
}

- (void)setUpWebView {
    // First create a WKWebViewConfiguration object so we can add a controller
    // pointing back to this ViewController.
    WKWebViewConfiguration *configuration = [[WKWebViewConfiguration alloc]
                                             init];
 //---Old uncomment together--> WKUserContentController *controller = [[WKUserContentController alloc] init];
    
    // Add a script handler for the "observe" call. This is added to every frame
    // in the document (window.webkit.messageHandlers.NAME).
    
  //---Old uncomment together-->[controller addScriptMessageHandler:self name:@"observe"];
 //---Old uncomment together--> configuration.userContentController = controller;
    
    // This is the URL to be loaded into the WKWebView.
    NSURL *jsbin = [[NSBundle mainBundle]URLForResource:@"AppControlTestWithWKWebView"  withExtension:@"html"];
    
    
     NSLog(@"jsbin %@",jsbin);
    // Initialize the WKWebView with the current frame and the configuration
    // setup above
    _webViewM = [[WKWebView alloc] initWithFrame:self.view.bounds
                                  configuration:configuration];
    
    
    // Load the jsbin URL into the WKWebView and then add it as a sub-view.
    [_webViewM loadRequest:[NSURLRequest requestWithURL:jsbin]];
    [self.container addSubview:_webViewM];
    
    _webViewM.wantsLayer = YES;
    
    
    
   
    /*  SET WKWEBVIEW CONSTRAINTS TO FOLLOW WINDOW SIZE  */
    
    NSLayoutConstraint *  constraintTop = [NSLayoutConstraint constraintWithItem:_webViewM  attribute:NSLayoutAttributeTop relatedBy:NSLayoutRelationEqual toItem:self.container attribute:NSLayoutAttributeTop multiplier:1.0f constant:0.f];
    
    
    NSLayoutConstraint *  constraintBottom = [NSLayoutConstraint constraintWithItem:_webViewM attribute:NSLayoutAttributeBottom relatedBy:NSLayoutRelationEqual toItem:self.container attribute:NSLayoutAttributeBottom multiplier:1.0f constant:0.f];
    
    NSLayoutConstraint *  constraintLeading= [NSLayoutConstraint constraintWithItem:_webViewM attribute: NSLayoutAttributeLeading relatedBy:NSLayoutRelationEqual toItem:self.container attribute:NSLayoutAttributeLeading multiplier:1.0f constant:0.f];
    
    NSLayoutConstraint *  constraintTrailing= [NSLayoutConstraint constraintWithItem:_webViewM attribute: NSLayoutAttributeTrailing relatedBy:NSLayoutRelationEqual toItem:self.container attribute:NSLayoutAttributeTrailing multiplier:1.0f constant:0.f];
    
    
    [self.container addConstraint:constraintTrailing];
    
    [self.container addConstraint:constraintLeading];
    [self.container addConstraint:constraintTop];
    [self.container addConstraint:constraintBottom];
    
    [_webViewM  setTranslatesAutoresizingMaskIntoConstraints: NO];
    webViewM2 = _webViewM;
}



        
- (void)viewDidLoad {
    [super viewDidLoad];
 
    [self setUpWebView];
  
}

//-- Direct call From  App Action to Webpage
- (IBAction)runTimeline:(id)sender {
    //[_window1 endSheet:_prefs];
    
    /*
    BOOL hasSheet = ([_window1 attachedSheet] != nil);
    if (hasSheet) {
        //-- We want to clos prefs and reverse animation of pref buttons.
        
        
        NSString * exec_prefs = @"window.myhypedocument.functions().closePrefs()";
        
        
        
        [_webViewM evaluateJavaScript:exec_prefs completionHandler:nil];
        [_window1 performSelector:@selector(  endSheet:  ) withObject:_prefs afterDelay:1.5];
    }
  */
    
    counter++;
    
     NSString *exec_template = @"window.myhypedocument.continueTimelineNamed('timeline1');$('#headline').html(\"received: %@\");";
    
    
   
   
    NSString *theMessage = [NSString stringWithFormat:@"Call from App = Run Timeline  %i times",counter];
    
     
    
    NSString *exec = [NSString stringWithFormat:exec_template, theMessage];
    //NSString *exec = [NSString stringWithFormat:exec_template, version];
    [_webViewM evaluateJavaScript:exec completionHandler:nil];
    
    
   
}


/*
 
//---Old uncomment together-->
 
//-- Calls From Webpage  to App

- (void)userContentController:(WKUserContentController *)userContentController
      didReceiveScriptMessage:(WKScriptMessage *)message {
 NSLog(@"Received event inVIEWCONTROLLER %@", message.body);
    // Check to make sure the name is correct
    //if ([message.name isEqualToString:@"observe"]) {
     [self callBackToWebPage:message];
  
    
    //}
    
}



//--execute the javascript from the callback
- (void)callBackToWebPage:(WKScriptMessage *)message
{
    NSString *theMessage = message.body;
    
    // Execute some JavaScript using the result
    NSString *exec_template = @"$('#headline').html(\"received: %@\");";
    NSString *exec = [NSString stringWithFormat:exec_template, theMessage];
    [_webViewM evaluateJavaScript:exec completionHandler:nil];
}
*/

+(void)callFromOtherController:(NSString *)message {
    
   
    
    [webViewM2 evaluateJavaScript:message completionHandler:nil];
    
    
    
}

@end
